/**
 * Code released under WTFPL [http://sam.zoy.org/wtfpl/]
 * 
 * @author Arnaud Pichery [http://coderpeon.ovh.org]
 */
package com.flexspy
{
	import flash.display.DisplayObject;
	import flash.events.KeyboardEvent;
	import mx.core.Application;
	
	public class FlexSpy
	{
		/**
		 * Register a sequence key that will trigger the show of the component tree window.
		 * 
		 * @param root Root of the displayed tree. It cannot be null
		 * @param modal true to display a modal window (default), false to display a modeless window.
		 */
		public static function registerKey(key: KeySequence, root: DisplayObject = null, modal: Boolean = true): void {
			if (root == null) {
				root = DisplayObject(Application.application);
			}
			
			root.addEventListener(KeyboardEvent.KEY_DOWN, function(event: KeyboardEvent): void {
				if (key.isPressed(event)) {
					show(root, modal);
				}
			});
		}
	
		/**
		 * Displays the tree of the specified DisplayObject (its children, the children of its children, etc.)
		 * 
		 * @param root Root of the displayed tree. If it is null, the current application is used.
		 * @param modal true to display a modal window (default), false to display a modeless window.
		 */
		public static function show(root: DisplayObject = null, modal: Boolean = true): void {
			ComponentTreeWnd.show(root, modal);
		}
	}
}